<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (12.0.1) on Sun Jan 12 21:47:51 EST 2020 -->
<title>MessageExchange (protean-core 1.0.1 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-01-12">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="MessageExchange (protean-core 1.0.1 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":6,"i1":6,"i2":6,"i3":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">io.gitlab.littlesaints.protean.exchanges</a></div>
<h2 title="Interface MessageExchange" class="title">Interface MessageExchange&lt;E&gt;</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>E</code> - The getType of messages in the exchange.</dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><code><a href="AbstractMessageExchange.html" title="class in io.gitlab.littlesaints.protean.exchanges">AbstractMessageExchange</a></code>, <code><a href="blocking/LinkedBlockingExchange.html" title="class in io.gitlab.littlesaints.protean.exchanges.blocking">LinkedBlockingExchange</a></code>, <code><a href="blocking/LinkedSyncTransferExchange.html" title="class in io.gitlab.littlesaints.protean.exchanges.blocking">LinkedSyncTransferExchange</a></code>, <code><a href="blocking/LinkedTransferExchange.html" title="class in io.gitlab.littlesaints.protean.exchanges.blocking">LinkedTransferExchange</a></code>, <code><a href="executor/UnOrderedExecutionExchange.html" title="class in io.gitlab.littlesaints.protean.exchanges.executor">UnOrderedExecutionExchange</a></code></dd>
</dl>
<hr>
<pre>public interface <span class="typeNameLabel">MessageExchange&lt;E&gt;</span></pre>
<div class="block">This is a queue for exchanging messages between producers and consumers.
 <br>
 The implementations are wrapper over existing queue implementations. They hide away the knowledge/code required to efficiently use them.
 The applications can use an implementation or switch to another, without make any code changes.
 It can also choose implementations based on their use case and whether the underlying has a different strategy for multiple or single producers.
 <br>
 It supports a variety of blocking and non-blocking operations.
 <br>
 All implementations support the notion of a terminal state. When a terminal element is submitted to the exchange, all the readers will receive it, marking the end of all future transmission.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.0</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<div class="memberSummary">
<table>
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Interface</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<td class="colFirst"><code>static interface&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="MessageExchange.Factory.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Factory</a></span></code></th>
<td class="colLast">
<div class="block">The factory method for all implementations.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static interface&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="MessageExchange.Reader.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Reader</a>&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;</span></code></th>
<td class="colLast">
<div class="block">An interface to read from a resource.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static interface&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="MessageExchange.Writer.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Writer</a>&lt;<a href="MessageExchange.Writer.html" title="type parameter in MessageExchange.Writer">E</a>&gt;</span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</li>
</ul>
</section>
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<div class="memberSummary">
<table>
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<td class="colFirst"><code>static <a href="../resources/Registry.html" title="class in io.gitlab.littlesaints.protean.resources">Registry</a>&lt;<a href="MessageExchange.Factory.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Factory</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#REGISTRY">REGISTRY</a></span></code></th>
<td class="colLast">
<div class="block">Repository for all configured executors.</div>
</td>
</tr>
</tbody>
</table>
</div>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<div class="memberSummary">
<div role="tablist" aria-orientation="horizontal"><button role="tab" aria-selected="true" aria-controls="memberSummary_tabpanel" tabindex="0" onkeydown="switchTab(event)" id="t0" class="activeTableTab">All Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t2" class="tableTab" onclick="show(2);">Instance Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t3" class="tableTab" onclick="show(4);">Abstract Methods</button></div>
<div id="memberSummary_tabpanel" role="tabpanel">
<table aria-labelledby="t0">
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor" id="i0">
<td class="colFirst"><code><a href="MessageExchange.Reader.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Reader</a>&lt;<a href="MessageExchange.html" title="type parameter in MessageExchange">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getReader()">getReader</a></span>()</code></th>
<td class="colLast">
<div class="block">Provides an instance of <a href="MessageExchange.Reader.html" title="interface in io.gitlab.littlesaints.protean.exchanges"><code>MessageExchange.Reader</code></a> for this exchange.</div>
</td>
</tr>
<tr class="rowColor" id="i1">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#isEmpty()">isEmpty</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor" id="i2">
<td class="colFirst"><code><a href="MessageExchange.Writer.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Writer</a>&lt;<a href="MessageExchange.html" title="type parameter in MessageExchange">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#newWriter()">newWriter</a></span>()</code></th>
<td class="colLast">
<div class="block">Provides an instance of <a href="MessageExchange.Writer.html" title="interface in io.gitlab.littlesaints.protean.exchanges"><code>MessageExchange.Writer</code></a> for this exchange.</div>
</td>
</tr>
<tr class="rowColor" id="i3">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#shutdown()">shutdown</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</tbody>
</table>
</div>
</div>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="REGISTRY">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>REGISTRY</h4>
<pre>static final&nbsp;<a href="../resources/Registry.html" title="class in io.gitlab.littlesaints.protean.resources">Registry</a>&lt;<a href="MessageExchange.Factory.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Factory</a>&gt; REGISTRY</pre>
<div class="block">Repository for all configured executors.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="getReader()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getReader</h4>
<pre class="methodSignature"><a href="MessageExchange.Reader.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Reader</a>&lt;<a href="MessageExchange.html" title="type parameter in MessageExchange">E</a>&gt;&nbsp;getReader()</pre>
<div class="block">Provides an instance of <a href="MessageExchange.Reader.html" title="interface in io.gitlab.littlesaints.protean.exchanges"><code>MessageExchange.Reader</code></a> for this exchange. The implementation can return a cached instance, if it's thread-safe.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a reader</dd>
</dl>
</li>
</ul>
<a id="newWriter()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>newWriter</h4>
<pre class="methodSignature"><a href="MessageExchange.Writer.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange.Writer</a>&lt;<a href="MessageExchange.html" title="type parameter in MessageExchange">E</a>&gt;&nbsp;newWriter()</pre>
<div class="block">Provides an instance of <a href="MessageExchange.Writer.html" title="interface in io.gitlab.littlesaints.protean.exchanges"><code>MessageExchange.Writer</code></a> for this exchange. The implementation can return a cached instance, if it's thread-safe.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a writer</dd>
</dl>
</li>
</ul>
<a id="isEmpty()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEmpty</h4>
<pre class="methodSignature">boolean&nbsp;isEmpty()</pre>
</li>
</ul>
<a id="shutdown()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>shutdown</h4>
<pre class="methodSignature">void&nbsp;shutdown()</pre>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
